package {
	
	import flash.display.MovieClip;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.Event;

	public class Character extends MovieClip {

		private var _dir: String;
		public var vel: Point;
		protected var speed: Number;
		private var _origX: Number;
		private var _origY: Number;

		public function Character(frames: Array, x:Number = 0, y:Number = 0) {
			this.x = x+(x%Main.TILE_SIZE);
			this.y = y+(y%Main.TILE_SIZE);

			this._origX = x;
			this._origY = y;

			this.vel = new Point(0, 0);
			this.speed = Main.MOVE_SPEED;

			for(var i:int=0;i<frames.length;i++) {
				addChildAt( newFrame(frames[i].x, frames[i].y, frames[i].visible), i );
			}
		}

		public function newFrame(x:int, y:int, visible:Boolean = false):Bitmap {
			var bmpData: BitmapData = new BitmapData(16,16,true);
			bmpData.copyPixels(
				Main.spriteSheet.bitmapData,
				new Rectangle(x*16, y*16, 16, 16),
				new Point(0, 0)
			);
			var bmp: Bitmap = new Bitmap(bmpData);
			bmp.visible = visible;
			return bmp;
		}

		public function showFrame(num:int):void {
			for (var i:int = 0; i < this.numChildren; i++) {
				if (i == num) {
					getChildAt(i).visible = true;
				} else {
					getChildAt(i).visible = false;
				}
			}
		}

		public function update(e:Event):void {
			this.x += this.vel.x;
			this.y += this.vel.y;
//			if (this.x < -Main.TILE_SIZE*6) this.x = -Main.TILE_SIZE*6;
//			if (this.x > Main.TILE_SIZE*6) this.x = Main.TILE_SIZE*6;
		}

		public function getPos():Point {
			return new Point(x, y);
		}

		public function velX(v:int):void {
			this.vel.x = v*this.speed;
		}

		public function velY(v:int):void {
			this.vel.y = v*this.speed;
		}

		public function moveTo(x:Number, y:Number):void {
			this.x = x;
			this.y = y;
		}

		public function moveX(x:Number):void {
			this.x = x;
		}

		public function resetPosition():void {
			this.x = _origX;
			this.y = _origY;
		}

	}

}
