package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.events.Event;

	public class Map extends Bitmap {
		


		private var _tileSize: int;
		public var vel: Point;
		private var _distance: Number;
		private var _speed: Number;

		public function Map(mapData:Array, posX:int = 0, posY:int = 0, tileSize:int = 16) {
			super( _drawTiles(mapData, tileSize) );
			this.x = posX;
			this.y = posY;

			this.vel = new Point();
			this._speed = Main.MOVE_SPEED;
			this._distance = 0;

			this._tileSize = tileSize;
		}

		private function _drawTiles(mapData:Array, tileSize:int):BitmapData {
			var bmpData:BitmapData = new BitmapData(mapData[0].length*tileSize, mapData.length*tileSize, true);
			for (var i:int=0;i<mapData.length;i++) {
				for (var f:int=0;f<mapData[i].length;f++) {
					bmpData.copyPixels(
						Main.spriteSheet.bitmapData,
						new Rectangle(mapData[i][f]*tileSize, 0, tileSize, tileSize),
						new Point(f*tileSize, i*tileSize)
					);
				}
			}
			return bmpData;
		}

		public function update(e:Event):void {
			this.x += this.vel.x;
			this.y += this.vel.y;

		}

		public function velX(v:int):void {
			this.vel.x = v*this._speed;
		}

		public function velY(v:int):void {
			this.vel.y = v*this._speed;
		}

		public function getVelX():Number {
			return this.vel.x;
		}

		public function getVelY():Number {
			return this.vel.y;
		}

	}

}
